#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import json
import sys
reload(sys)
sys.setdefaultencoding("utf-8")
from tianji_sdk import *

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
__strTopDir__ = os.path.dirname(__strModuleDir__)
if __strTopDir__ not in sys.path:
    sys.path.append(__strTopDir__)

from util import CProcess

class CClustersAg():
    def __init__(self, strLog = ""):
        self.m_strLog = strLog

    def make_conf(self):
        try:
            return self.make_conf_tianji()
        except Exception,e:
            print  "Could not find tianji %s" % str(e)
        return self.make_conf_v2()

    def make_conf_v2(self):
        strCmd = "sudo docker inspect $(sudo docker ps | grep tianmu_api |awk '{print $1}')| grep '/L1root/L1tools/main/config' |grep -v Source|awk -F [:\\\"] '{print $2}'"
        cmd_res = CProcess.RunCmdSubprocess(strCmd, False)
        strCmd = "cat %s/container_arrangement.csv | grep ,ag, | awk -F , '{print $1,$4,$5}'  | sed 's/--/_/g' | sed 's/-/ /g' | awk '{print $1,$(NF-1),$NF}' | sed 's/ /,/g'" % cmd_res.strip()
        cmd_res = CProcess.RunCmdSubprocess(strCmd, False)
        # public_apsara_ssd_ots,10.0.52.21,docker010000052021
        mapRes = {}
        for strLine in cmd_res.strip().split("\n"):
            if not strLine:
                continue
            lsItems = strLine.split(',')
            mapTemp = {'cluster':lsItems[0], 'hostname':lsItems[2], 'ip':lsItems[1]}
            strGroup = lsItems[0].split('_')[-1]
            if strGroup not in mapRes:
                mapRes[strGroup] = []
            mapRes[strGroup].append(mapTemp)
        return mapRes

    def make_conf_tianji(self):
        kvPath = "/apsara/cloud/app/tianji/TianjiClient#/service_manager/current/conf.global/kv.json"
        kvConfig = json.loads(open(kvPath).read())["KeyValues"]

        #天基配置
        tianji_conf={}
        tianji_conf['access_key_id'] = kvConfig["account.all.accesskey-id"]
        tianji_conf['access_key_secret'] = kvConfig["account.all.accesskey-secret"]
        tianji_conf['beiming_address'] = ''
        tianji_conf['primary_api_address'] = 0
        tianji_conf['project_name'] = ''
        tianji_conf['tianji_api_addresses'] = ['http://{0}-api.tianji.{1}'.format(kvConfig["REGION"], kvConfig["intranet-domain"])]

        tianji_conf_str = json.dumps(tianji_conf,sort_keys=True,indent=4)
        tianji_conf_file = "tianji.conf"
        if not os.path.exists(tianji_conf_file):
            with open(tianji_conf_file,"w") as fp:
                fp.write(tianji_conf_str)

        tj_api = TianjiAPI(tianji_conf_file)
        #获取ag配置
        agent_conf = {}
        project_list = tj_api.ListProjects().keys()
        for project in project_list:
            cluster_list = tj_api.ListClusters(project)
            agent_list = []
            for cluster in cluster_list:
                machine_sr_list = tj_api.ListMachineSRByCluster(cluster)
                #print  ("project:{0} cluster:{1} machine_sr_list:{2}".format(project,cluster,machine_sr_list), True, self.m_strLog)
                machine_sr_info = {}
                for mr in machine_sr_list:
                    service,sr = mr["serverrole"].split(".")
                    if not machine_sr_info.has_key(service):
                        machine_sr_info[service] = {}
                    if not machine_sr_info[service].has_key(sr):
                        machine_sr_info[service][sr] = []
                    machine_sr_info[service][sr].append(mr["hostname"])
                if not machine_sr_info.has_key("pangu"):
                    continue

                try:
                    hostname = ""
                    if project == "ecs":
                        ret = tj_api.GetClusterMachineGroup(cluster, "AdminGateway")
                        if ret:
                            tmp = json.loads(ret)[0]
                            if tmp in machine_sr_info["pangu"]["PanguTools#"]:
                                hostname = tmp
                        #if machine_sr_info.has_key("ecs-init"):
                        #    hostname = machine_sr_info["ecs-init"]["EcsAg#"][0]
                        #elif machine_sr_info.has_key("EcsBssTools"):
                        #    hostname = machine_sr_info["EcsBssTools"]["BssToolJob#"][0]
                        #else:
                        #    print  ("project:{0} cluster:{1} AG not find".format(project,cluster), False, self.m_strLog)
                    elif project == "hologres" :
                        ret = tj_api.GetClusterMachineGroup(cluster, "ApsaraAG")
                        if ret:
                            tmp = json.loads(ret)[0]
                            if tmp in machine_sr_info["pangu"]["PanguTools#"]:
                                hostname = tmp
                    else:
                        hostname = machine_sr_info["pangu"]["PanguTools#"][0]
                    if hostname:
                        ip = tj_api.GetMachineInfo(hostname, "ip")["ip"]
                        agent_list.append({"cluster":cluster,"hostname":hostname, "ip":ip})
                except Exception as e:
                    print  "project:{0} cluster:{1} get AG fail {2}".format(project,cluster, str(e))
            if agent_list:
                agent_conf[project] = agent_list

        conf = agent_conf

        #conf_str = json.dumps(conf,sort_keys=True,indent=4)
        #with open("ag.conf","w") as fp:
        #    fp.write(conf_str)
        return conf

if __name__ == "__main__":
    conf = CClustersAg("cluster_portal").make_conf()
    print json.dumps(conf, indent = 4)

    resultstr = ""
    for key, v in conf.items():
        for each in v:
            resultstr = resultstr + each["ip"] + '\n'
    dstfile = open("aglist", "w")
    dstfile.write(resultstr)
    dstfile.close();


