#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import time;
import socket;
import json;
import urllib;
import urllib2;
from common import CEnv, CGlobal;
from flag import GetGlobalFlag;
from exception import CStrException,CFatalException;
from log import fatal, error, warning, info, debug;
from run_env import CRunEnvClusterInfo;

class CAction:
    def __init__(self, oReport, oOpr):
        self.m_oOpr = oOpr;
        self.m_oReport = oReport;

    def Execute(self, strRole, strCaseName, strLevel, strReport):
        self.m_oReport.MonitorAction(self.m_oOpr, strRole, strCaseName, strLevel, strReport);

class CGlobalMonitor:
    def __init__(self, oClusterInfo):
        self.m_oClusterInfo = oClusterInfo;

    def MonitorAction(self, oHttp, strRole, strCaseName, strLevel, strReport):
        # subject: <XXX>,        // 主题;
        #serverrole: <XXX>,    // 角色;
        #hostname: <XXX>,    // 主机名;
        #port: <XXX>,             // 端口, current is empty, remove it;
        #level: <XXX>,           // 告警级别;
        #when: <XXX>,          // 发生时间;
        #desc: <XXX>,           // 描述;
        mapReport = {'subject' : strCaseName, 'serverrole' : 'pangu.%s' %strRole, 'hostname' : CEnv.GetLocalHost(),
                     'level' : strLevel.lower(), 'when' : '%s' %int(time.time() * (10**6)), 'desc' : strReport};

        info('report to global-monitor:' + str(mapReport), True);
        strFormatUrl = GetGlobalFlag('pangu_global_monitor_report_url');
        if -1 == strFormatUrl.find('%s'):
            info("global monitor is abs path(%s), only put to server once!" %(strFormatUrl), True);
            self.__DoOnceAction(oHttp, strFormatUrl, mapReport);
        else:
            self.__ActionForAllGlobalMonitor(oHttp, strFormatUrl, mapReport);

    def __ActionForAllGlobalMonitor(self, oHttp, strFormatUrl, mapReport):
        nEnvMode = int(GetGlobalFlag("pangu_common_EnvMode"));
        strSupervisorRole = "PanguSupervisor";
        if 0 == nEnvMode:
            strSupervisorRole = "PanguMaster";

        nSucc = 0;
        for strGMIp in self.m_oClusterInfo.GetIplistByRole(strSupervisorRole):
            if self.__DoOnceAction(oHttp, strFormatUrl %strGMIp, mapReport):
                nSucc += 1;
                break;

        if 0 == nSucc:
            fatal("threre is no valid global monitor!", True);
            raise CStrException("threre is no valid global monitor!");

    def __DoOnceAction(self, oHttp, strUrl, mapReport):
        try:
            oHttp.Put(strUrl, mapReport);
            return True;
        except Exception, e:
            error(str(e), True);

        return False;

class CTianjiMonitor:
    def __init__(self):
        pass;

    def MonitorAction(self, oHttp, strRole, strCaseName, strLevel, strReport):
        mapReport = {'monitor' : strCaseName, 'level' : strLevel.lower(), 'description' : strReport};

        #put to tianji
        strTianjiRportUrl = GetGlobalFlag("pangu_tianji_monitor_report_url") + "?hostname=%s&serverrole=pangu.%s%%23" %(CEnv.GetLocalHost(), strRole);
        info("tianji-monitor info:%s" %str(mapReport), True);
        oHttp.Put(strTianjiRportUrl, mapReport);


class CAliMonitor:
    def __init__(self, oClusterInfo):
        self.m_oClusterInfo = oClusterInfo;

    def MonitorAction(self, oHttp, strRole, strCaseName, strLevel, strReport):
        #http://127.0.0.1:15776/passive?name=xxx&msg=xxx
        #name:即监控项名称 （必须配置在发送被动消息的服务器上）
        #msg：所发送的数据 （格式和监控项脚本输出规范一致，脚本输出格式 [http://docs.alibaba-inc.com/pages/viewpage.action?pageId=100086344] ）
        #注意：参数需要urlencode

        #msg ：（json格式）
        #{
        #    "collection_flag": 0,
        #    "error_info": "",
        #    "MSG": [
        #        {
        #            "qps": 1000,
        #            "rt": 30
        #        }
        #    ]
        #}
        if not CGlobal.IsNeedAlarm(strLevel):
            info("case name(%s) level(%s) needn't alarm to ali monitor" %(strCaseName, strLevel), True);
            return;

        mapMsgInternal = {'ret' : 1, 'subject' : strCaseName, 'serverrole' : 'pangu.%s' %strRole, 'hostname' : CEnv.GetLocalHost(),
                     'level' : strLevel.lower(), 'when' : '%s' %int(time.time() * (10**6)), 'desc' : strReport};
        mapMsg = {"collection_flag": 0, "error_info": strReport, "MSG" : [mapMsgInternal]};
        strMsg = urllib.urlencode({'msg' : json.dumps(mapMsg)})[4:];
        mapReport = {'name' : strCaseName, 'msg' : strMsg};
        info('report to ali-monitor:' + str(mapReport), True);
        oHttp.Get(GetGlobalFlag("pangu_ali_monitor_post_url"), mapReport);

if '__main__' == __name__:
    from http import CHttp;
    from flag import SetGlobalFlag;
    SetGlobalFlag("pangu_common_EnvMode", 0);
    oHttp = CHttp();
    oMonitor = CAliMonitor();
    oMonitor.MonitorAction(oHttp, "test_clustername", "test_monitor2", "INFO", "info message");
    oMonitor.MonitorAction(oHttp, "test_clustername", "test_monitor_4_pangu_item", "ERROR", "test for report monitor");
