#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import time;
import json;
from common import CProcess;
from exception import CStrException,CFatalException;
from log import fatal, error, warning, info, debug;

class CDayuConst:
    M_ME_BIN = "/bin/me";
    M_TIANJI_ROLE_MAP = {"PanguMaster" : "pangu_master", "PanguChunkserver" : "pangu_chunkserver", "all" : "watch_dog"};

class CDayu:
    def __init__(self):
        self.m_oClusterInfo = CDayuClusterInfo();

    def GetLocalIp(self):
        return self.m_oClusterInfo._GetLocalIp();

class CDayuClusterInfo:
    def __init__(self):
        self.m_strClusterName = ''
        self.m_strAgIp = ''
        self.m_strLocalIp = '';

        strOutput = CProcess.RunCmd(CDayuConst.M_ME_BIN)
        for strLine in strOutput.split('\n'):
            strLine = strLine.strip()
            if strLine.startswith('Local_cluster:'):
                self.m_strClusterName = strLine.split(':', 2)[1].strip()
            elif strLine.startswith('Local_admingateway:'):
                self.m_strAgIp = strLine.split(':', 2)[1].strip()
            elif strLine.startswith('Local_Address:'):
                self.m_strLocalIp = strLine.split(':', 2)[1].strip()

        if not self.m_strClusterName or not self.m_strAgIp:
            raise CStrExceptoin("can not get cluster name or ag");

    def __GetDayuRole(self, strRole):
        return CDayuConst.M_TIANJI_ROLE_MAP[strRole];

    def _GetLocalIp(self):
        return self.m_strLocalIp;

    def IsLocalExistRole(self, strRole):
        #Local_ip_info: role_admingateway|role_fuxi_master|role_nuwa|role_nuwa_proxy|role_package_manager|role_shennong_inspector|role_watch_dog|clusterName_AT-Pangu-Benchmark-Test-3
        strOutput = CProcess.RunCmd(CDayuConst.M_ME_BIN)
        strRoleInfo= "";
        for strLine in strOutput.split('\n'):
            if strLine.startswith("Local_ip_info:"):
                strRoleInfo = strLine.split(':', 1)[1].strip();
                break;

        if not strRoleInfo:
            raise CStrException("can not get Local_ip_info in /bin/me output");

        lsRoleInfo = [x.strip()[5:] for x in strRoleInfo.split('|')]
        return self.__GetDayuRole(strRole) in lsRoleInfo;

    def GetHostnameListByRole(self, strRole):
        '''
        in dayu env, can't get hostname by ip
        '''
        #get role.def
        return self.GetIplistByRole(strRole);

    def GetIplistByRole(self, strRole):
        if 'all' == strRole.lower():
            return self.GetAllIplist();

        strOutput = CProcess.RunCmd("%s --ip %s_%s" %(CDayuConst.M_ME_BIN, self.m_strClusterName, self.__GetDayuRole(strRole)))
        return list(set([x.strip() for x in strOutput.split(':', 2)[1].split('|') if len(x.strip()) > 0]));

    def GetAllIplist(self):
        strVal = CProcess.RunCmd("%s --ip %s" %(CDayuConst.M_ME_BIN, self.m_strClusterName))
        strVal = strVal.split(')')[1];
        return  [x.strip() for x in strVal.split('|') if len(x.strip()) > 0];

