#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import socket;
import fcntl;
import struct;
import commands;
import string;
import json;
import io;
import threading;
import traceback;
import copy;
import datetime
import subprocess
import time
import shutil
import traceback;
import subprocess
import select
import time
import signal

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))

from common import CProcess
from log import fatal, error, warning, info, debug;

class CDispatcher:
    def __init__(self, lsCommand, lsIp, strErrorInfoPath, bTestConnect):
        ServerThread.COMMANDLIST = lsCommand
        ServerThread.glsIp = copy.deepcopy(lsIp)
        ServerThread.gTotal = len(lsIp)
        ServerThread.gStrErrorInfoPath = strErrorInfoPath
        ServerThread.gTestConnect = bTestConnect;


    def ExecuteWithTimeout(self, nThreadCount, nTimeout):
        # create thread and start
        threads = [];
        for index in xrange(0, nThreadCount):
            oThread = ServerThread();
            threads.append(oThread);
            oThread.start();

        # 应该用thread.join 等待线程的退出，但是有时候Popen会陷入，导致超时检查的poll 无效
        # 增加一个补救措施，当ip列表处理完成后，再等待一段时间，不管是否成功，直接退出，
        # 确保脚本能执行完毕
        waitTimeSecond = nTimeout

        while True:
            ServerThread.gLock.acquire();
            ipLeft = len(ServerThread.glsIp);
            totalLeft = ServerThread.gTotal;
            ServerThread.gLock.release();
            # 所有的任务都处理完了，直接退出
            if totalLeft == 0:
                info("all task process success")
                break;

            if ipLeft == 0:
                if waitTimeSecond > 0:
                    time.sleep (1);
                    waitTimeSecond -= 1;
                    info("timeout sleep")
                else:
                   # cmd = "pkill -9 -f " + sys.argv[0];
                   # info("timeout kill, cmd is " + cmd);
                   # nRet, strOutput = CProcess.RunCmd4NoException(cmd)
                    print "timeout, break"
                    break;
            else:
                time.sleep(1);
                info("timeout sleep, iplist len is " + '%d' %len(ServerThread.glsIp));
                continue;

class ServerThread(threading.Thread):
    COMMANDLIST = []
    gTotal = 0
    glsIp = []
    gLock = threading.RLock()
    gStrErrorInfoPath = ''
    gTestConnect = False;

    def __init__(self):
        threading.Thread.__init__(self);

    def ExecCommandTimeout(self, cmd, timeout = 20):
        tryCount = timeout * 10;
        proc = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell = True)
        while True:
            ret1 = subprocess.Popen.poll(proc)
            if ret1 is None :
                if tryCount > 0:
                    tryCount -= 1;
                    time.sleep(0.1);
                else:
                    # 超时
                    os.kill(proc.pid, signal.SIGKILL),
                    return -1, 'command timeout: ' + cmd;
            elif ret1 == 0:  # 成功
                (stdoutdata, stderrdata) = proc.communicate()
                return 0, stdoutdata;
            else: # 失败
                (stdoutdata, stderrdata) = proc.communicate()
                if stderrdata != '':
                    return 1, stderrdata;
                elif stdoutdata != '':
                    return 1, "Output Log:\n" + stdoutdata;
                else:
                    return 1, "";

    def DeployOneAgent(self, ip):
        # 判断机器是否通, 不通则跳过这台机器
        if ServerThread.gTestConnect:
            nRet, str = self.ExecCommandTimeout('ssh ' + ip + ' -l admin free');
            if nRet != 0:
                return False, str;

            # 判断是否有重复进程, 跳过本机
            nRet, localip = commands.getstatusoutput("hostname -i");
            if nRet == 0  and localip != ip:
                nRet, str = commands.getstatusoutput('ssh ' + ip + ' -l admin ps -ef|grep data_collect');
                if nRet == 0 and len(str) > 0:
                    return False, "data_collect process is runnig"

        for command in ServerThread.COMMANDLIST:
            cmd = command['cmd'].replace('ip_address', ip)
            if command.has_key('timeout'):
                nRet, str = self.ExecCommandTimeout(cmd, command['timeout'])
            else:
                nRet, str = self.ExecCommandTimeout(cmd)
            if nRet != 0:
                return False, str;
        return True, str;

    def run(self):
        while True:
            ServerThread.gLock.acquire();
            size = len(ServerThread.glsIp);
            if size > 0:
                ip = ServerThread.glsIp.pop();
            ServerThread.gLock.release();
            if size > 0:
                try:
                    ret, str = self.DeployOneAgent(ip.strip());
                    ServerThread.gLock.acquire();
                    ServerThread.gTotal -= 1;
                    ServerThread.gLock.release();
                    if ret == True:
                        info (ip.strip() + " success" , True);
                        if str != '':
                            open(os.path.join(ServerThread.gStrErrorInfoPath, ip + '.ok'), 'w').write(str)
                    else:
                        info (ip.strip() + " failed: " + str, True)
                        if str != '':
                            open(os.path.join(ServerThread.gStrErrorInfoPath, ip + '.error'), 'w').write(str)
                except Exception, e:
                    info("!!%s" %e);
            else:
                break;

