#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import time;

class CFlagException(Exception):
    pass

def GetGlobalFlag(strFlagName, bIsGetSetTime = False):
    try:
        lsInfo = _CGlobalFlag.GetInstance().GetVal(strFlagName);
        return lsInfo[1] if bIsGetSetTime else lsInfo[0];
    except:
        raise CFlagException('[global-flag] key(%s) not exist!'%strFlagName);

def SetGlobalFlag(strFlagName, oVal, fSetTime = 0):
    _CGlobalFlag.GetInstance().Set(strFlagName, oVal, fSetTime);

class _CGlobalFlag:
    M_SINGLE_OBJ = None;
    def __init__(self):
        self.m_mapGlobalFlag = {};

    @staticmethod
    def GetInstance():
         if not _CGlobalFlag.M_SINGLE_OBJ:
             _CGlobalFlag.M_SINGLE_OBJ = _CGlobalFlag();
             for strKey, strDesc, oVal in G_GLOBAL_FLAG_LIST:
                 _CGlobalFlag.M_SINGLE_OBJ.Set(strKey, oVal, strDesc);

         return _CGlobalFlag.M_SINGLE_OBJ;

    def GetVal(self, strKey):
        return self.m_mapGlobalFlag[strKey.upper()];

    def Set(self, strKey, strVal, fSetTime = 0):
        if not fSetTime:
            fSetTime = time.time();
        self.m_mapGlobalFlag[strKey.upper()] = (strVal, fSetTime);

G_GLOBAL_FLAG_LIST = [ \
#format: [key, comments, val]
['pangu_common_EnvMode', "monitor running env; 1:tianji, 0: dayu", 1],
['pangu_global_monitor_report_url', "global monitor http server address", "http://%s:10264/SetPanguMonitor"],
['pangu_tianji_monitor_report_url', "tianji monitor report url", "http://127.0.0.1:7070/api/v5/SetServerroleMonitor"],
['pangu_tianji_query_host_url', "tianji querey ip from host name url", "http://127.0.0.1:7070/api/v3/column/m.ip"],
['pangu_ali_monitor_post_url', "ali monitor post url", "http://127.0.0.1:15776/passive"],
['pangu_monitor_runing_interval', "monitor running intervl", 10],
['pangu_monitor_log_level', "log level", "info"],
['pangu_monitor_include_item', "check item include list, split by ','", ""],
['pangu_monitor_exclude_item', "check item exclude list, split by ','", ""]
]
