#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os
import os.path
import sys
__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
__strTopDir__ = os.path.dirname(__strCurrentDir__)
if __strTopDir__ not in sys.path:
    sys.path.insert(0, __strTopDir__)
if __strCurrentDir__  not in sys.path:
    sys.path.insert(0, __strCurrentDir__)

from log import error
from common import CProcess
from jinja2 import Environment, FileSystemLoader, Undefined, UndefinedError;

class CMyEnvironment(Environment):
    def __init__(self, strTmpDir = os.path.join(__strCurrentDir__, '..', 'template')):
        Environment.__init__(self, loader = FileSystemLoader(strTmpDir), extensions=['jinja2.ext.loopcontrols']); 

    def getattr(self, obj, attribute):
        """Get an item or attribute of an object but prefer the attribute.
        Unlike :meth:`getitem` the attribute *must* be a bytestring.
        """
        try:
            return getattr(obj, attribute)
        except Exception, e:
            pass

        try:
            return obj[attribute];
        except Exception, e:
            error(str(e));
            return "";

class CHtmlGenerator:
   
    def __init__(self):
        pass

    def LoadResult(self, resultPath):
        pass

    def GenReport(self):
        pass

    def AddSpark4Context(self, oReport):
        oRet = None;
        if isinstance(oReport, dict):
            oRet = dict()
            for strKey, oVal in oReport.items():
                oRet[strKey.strip().upper().replace(' ', '_')] = self.AddSpark4Context(oVal);
        elif isinstance(oReport, list):
            oRet = list()
            for strVal in oReport:
                oRet.append(self.AddSpark4Context(strVal));
        elif isinstance(oReport, float):
            oRet = round(oReport, 3);
        elif isinstance(oReport, tuple):
            # just consider pair for now
            oRet = (self.AddSpark4Context(oReport[0]), self.AddSpark4Context(oReport[1]))
        else:
            oRet = oReport

        return oRet;

    def Apply(self, strTplContent, lsCssFile, lsScriptFile):
        strCss = ''
        for cssFile in lsCssFile:
            strCss += open(os.path.join(__strCurrentDir__, '..', 'template', cssFile), 'r').read() + '\n'
        strTplContent = strTplContent.replace('#$#%s#*#' %str('GLOBAL_CSS_CONTENT').upper(), strCss).strip()

        strScript = ''
        for scriptFile in lsScriptFile:
            strScript =  open(os.path.join(__strCurrentDir__, '..', 'template', scriptFile), 'r').read()
            strTplContent = strTplContent.replace('#$#%s#*#' %str('GLOBAL_JS_CONTENT').upper(), strScript, 1).strip()
        return strTplContent

    def GenHtmlReport(self, templateFile, lsCssFile, lsScriptFile):
        strTplContent = '';
        try:
            mapReport = self.AddSpark4Context(self.GenReport())
            env = CMyEnvironment();
            oTpl = env.get_template(templateFile)
            strTplContent = oTpl.render({'AUTO_TEST' : mapReport})
            strTplContent = self.Apply(strTplContent, lsCssFile, lsScriptFile)
        except Exception, e:
            error(str(e), True)
        
        return strTplContent

