#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import logging;
from logging.handlers import RotatingFileHandler;
from console import CConsole;
from flag import GetGlobalFlag;

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)

def fatal(strInfo, bPrint = False, strApp = 'monitor'):
    if bPrint:
        CConsole.ColorPrint(strInfo, 'COLOR_RED');

    _CLog.GetInstance(strApp).fatal(strInfo);
    return strInfo

def error(strInfo, bPrint = False, strApp = 'monitor'):
    if bPrint:
        CConsole.ColorPrint(strInfo, 'COLOR_PUPPLE');

    _CLog.GetInstance(strApp).error(strInfo);
    return strInfo

def warning(strInfo, bPrint = False, strApp = 'monitor'):
    if bPrint:
        CConsole.ColorPrint(strInfo, 'COLOR_GREEN');

    _CLog.GetInstance(strApp).warning(strInfo);
    return strInfo

def info(strInfo, bPrint = False, strApp = 'monitor'):
    if bPrint:
        CConsole.ColorPrint(strInfo, 'COLOR_CYAN');

    _CLog.GetInstance(strApp).info(strInfo);
    return strInfo

def debug(strInfo, bPrint = False, strApp = 'monitor'):
    if bPrint:
        CConsole.ColorPrint(strInfo, 'COLOR_BLUE');

    _CLog.GetInstance(strApp).debug(strInfo);
    return strInfo;

class _CLog:
    M_LOG_OBJ_MAP = {};
    M_LOG_MAX_BYTE = 10240000
    M_LOG_MAX_BACKUP = 300
    @staticmethod
    def GetLogLevel():
        mapLogLevel = {'debug' : logging.DEBUG, 'info' : logging.INFO, 'warning' : logging.WARNING, 'error' : logging.ERROR, 'critical' : logging.CRITICAL, 'fatal' : logging.FATAL};
        strLogLevel = GetGlobalFlag('pangu_monitor_log_level');
        if strLogLevel not in mapLogLevel:
            return logging.DEBUG;

        return mapLogLevel[strLogLevel];

    @staticmethod
    def GetInstance(strApp):
        if strApp in _CLog.M_LOG_OBJ_MAP:
            return _CLog.M_LOG_OBJ_MAP[strApp];

        strLogPath = "%s/log/%s.LOG" %(__strModuleDir__, strApp);
        oLog = _CLog.Create(strLogPath, _CLog.M_LOG_MAX_BYTE, _CLog.M_LOG_MAX_BACKUP, _CLog.GetLogLevel())
        _CLog.M_LOG_OBJ_MAP[strApp] = oLog;

        return oLog;

    @staticmethod
    def Create(strLogFile, nMaxBytes = 10240000, nBackupCount = 50, nLogLevel = logging.DEBUG, strMode = 'w'):
        #if ./log not exist, create it
        strLogDir = os.path.dirname(strLogFile);
        if not os.path.isdir(strLogDir):
            os.makedirs(strLogDir);

        oFormat = logging.Formatter('[%(asctime)s %(levelname)s] %(message)s')
        oLogHandler = RotatingFileHandler(strLogFile, strMode, nMaxBytes, nBackupCount)
        oLogHandler.setFormatter(oFormat)

        oLog = logging.getLogger(strLogFile)
        oLog.addHandler(oLogHandler)
        oLog.setLevel(nLogLevel)

        return oLog;

if '__main__' == __name__:
    fatal("fatal test");
    error("errot test", True);
    warning('warnign test', False, 'aaa');
    info('info test', True, 'bbb');
    debug('debug test', False, 'ccc');
