#!/usr/bin/env python
import os;
import time;
import smtplib;
from email.MIMEMultipart import MIMEMultipart
from email.MIMEText import MIMEText
from email.MIMEImage import MIMEImage
from email.header import Header
from email.Utils import COMMASPACE, formatdate
from email.MIMEBase import MIMEBase
from email import Encoders
from log import error
from common import CStrException;

class CMailSender:
    M_SMTP_ADDR = "smtp-inc.alibaba-inc.com:25";
    def __init__(self, strUsr = '', strPasswd = '', strSMTPSvr = ''):
        self.m_strUsr = strUsr.strip();
        if len(self.m_strUsr) <= 0:
            self.m_strUsr = 'pangu-reporter@alibaba-inc.com';

        self.m_strPasswd = strPasswd.strip();
        if '' == self.m_strPasswd:
            self.m_strPasswd = "private@045015";

        self.m_strSMTPSvr = strSMTPSvr.strip();
        if '' == self.m_strSMTPSvr:
            self.m_strSMTPSvr = CMailSender.M_SMTP_ADDR;

    def Send(self, lsMailTo, strSubject, strSendContent, lsMailCc = [], lsImgFile = [], lsTxtFiles = [], nRetry = 11):
        strErr = '';
        for i in xrange(0, nRetry):
            try:
                self.__Send(lsMailTo, strSubject, strSendContent, lsMailCc, lsImgFile, lsTxtFiles);
                return;
            except Exception, e:
                error(str(e), True);
                strErr = str(e);
                time.sleep(i * 2);

        raise CStrException('Send mail failed!\n' + strErr);

    def __Send(self, lsMailTo, strSubject, strSendContent, lsMailCc = [], lsImgFile = [], lsTxtFiles = []):
        #for test
        #lsMailTo = ['jiangbin.lin@aliyun-inc.com'];
        #lsMailCc = [];

        try:
            strSendContent = strSendContent.encode('utf-8');
        except Exception, e:
            error(str(e));

        oMsg = MIMEMultipart();
        oMsg['From'] = self.m_strUsr;
        oMsg['To'] = ','.join(set(lsMailTo));
        oMsg['Date'] = formatdate(localtime=True);
        oMsg['Subject'] = Header(strSubject, 'utf-8');
        oMsg.attach(MIMEText(strSendContent, 'html', _charset='utf-8'));

        #append photo to mail
        nIndex = 1;
        for strImgFile in lsImgFile:
            if (not os.path.exists(strImgFile)):
                nIndex = nIndex + 1;
                continue;

            fp = open(strImgFile, "rb");
            oMsgImage = MIMEImage(fp.read());
            fp.close();

            oMsgImage.add_header("content-id", "<image%s>" % str(nIndex));
            oMsgImage.add_header("content-type", "image/png");
            nIndex = nIndex + 1;
            oMsg.attach(oMsgImage);

        #append text file to mail
        for strTxtFile in lsTxtFiles:
            oMsgTxt = MIMEText(open(strTxtFile, 'r').read(), 'base64', 'utf-8');
            oMsgTxt['Content-Type'] = 'application/octet-stream';
            oMsgTxt['Content-Disposition'] = 'attachment; filename="%s"' %(os.path.basename(strTxtFile));
            oMsg.attach(oMsgTxt);

        if len(lsMailCc) > 0 :
            oMsg["Cc"] = ','.join(lsMailCc);
            #append mailcc to send list
            lsMailTo.extend(lsMailCc);

        lsMailTo = list(set(lsMailTo));

        #send mail
        oSmtpServer = smtplib.SMTP();
        oRet = oSmtpServer.connect(self.m_strSMTPSvr);
        oSmtpServer.login(self.m_strUsr, self.m_strPasswd);
        oSmtpServer.sendmail(self.m_strUsr, lsMailTo, oMsg.as_string())
        oSmtpServer.quit()

if '__main__' == __name__:
    oMail = CMailSender();
    oMail.Send(['jiangbin.lin@aliyun-inc.com', 'jiangbin.lin@alibaba-inc.com'], 'mail subject', 'Hello, test!', [ 'jiangbin.lin@aliyun-inc.com', 'jiangbin.lin@alibaba-inc.com'], []);
