#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import os.path;
import json;
import sys;
import datetime;
import time;
import codecs;
import traceback;
import shutil;

from common import CProcess;
from log import error, debug, info, warning;

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))

class COssAccess:

    def __init__(self):
        pass;

    # 结果解析, 结果形如
    #
    #AT-5KN
    #AT-OTS-Main-016
    #AT-OTS-Replicate-016
    #
    #common prefix list number is: 14
    #request times is: 1
    #0.110(s) elapsed0.062(s) elapsed
    def SplitList(self, strInput):
        lsClusters = []
        for each in strInput.split('\n'):
            if each.find("elapsed") != -1 or each.find("common prefix list number") != -1 or \
               each.find("request times is") != -1 or len(each) == 0:
                continue;
            lsClusters.append(each);
        return lsClusters;

    def SetOssParam(self):
        try:
            osscmd_config = json.loads(open(os.path.join(__strCurrentDir__, '../conf', 'osscmd_config.json'), 'r').read())
            nRet, strOutput = CProcess.RunCmd4NoException('sudo osscmd config --host=%s --id=%s --key=%s'\
                    %(osscmd_config['host'], osscmd_config['accessid'], osscmd_config['accesskey']))
            if nRet != 0:
                error(traceback.format_exc())
                error(strOutput)
                raise Exception(strOutput)
        except Exception as e:
            error(traceback.format_exc());
            raise e;

    # 列出集群列表
    def ListDirFromOSS(self, oss_dir):
        try:
            nRet, strOutput = CProcess.RunCmd4NoException('sudo osscmd listalldir  ' + oss_dir)
            if nRet != 0:
                raise Exception(strOutput)
            return self.SplitList(strOutput);

        except Exception, e:
            error(traceback.format_exc());
            raise e;

    # 从oss 上下载数据, 如果type 为 last，则对同一个集群，只下载最新的数据
    def DownloadFromOSS(self, local_path, oss_dir, clusterName, type):
        try:
            # 获取一个集群的列表
            nRet, strOutput = CProcess.RunCmd4NoException('sudo osscmd listalldir  ' + oss_dir + clusterName)
            if nRet != 0:
                raise Exception(strOutput)

            ls = self.SplitList(strOutput)
            ls.sort(reverse = True);

            for each in ls:

                strCmd = "sudo osscmd get " + oss_dir + clusterName + "/" + each + "/" + clusterName + "_result.json "
                resultPath = local_path + each + "#" + clusterName + "_result.json";

                nRet, strOutput = CProcess.RunCmd4NoException(strCmd + " " + resultPath);
                if nRet != 0:
                    raise Exception(strOutput)

                warning("[DONE] Download " + resultPath + " result, success!", True);

                if type == "last":
                    break;

        except Exception, e:
            error(traceback.format_exc(), True);
            pass;


if '__main__' == __name__:

    oss_path = 'oss://apsara-release/pangu-environment-check-result/';
    result_path = "./data/"

    # 清理目标目录
    if  os.path.exists(result_path):
        shutil.rmtree(result_path)
    os.makedirs(result_path)

    downloader = COssAccess();
    downloader.SetOssParam();

    # 列出集群列表，并将结果下载下来
    lsClusters = downloader.ListDirFromOSS(oss_path);
    for clusterName in lsClusters:
        downloader.DownloadFromOSS(result_path, oss_path, clusterName, "last");


