#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import datetime;
import time;
import json;
import uuid;
import sys

reload(sys)

sys.setdefaultencoding('utf-8')

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
__strTopDir__ = os.path.dirname(__strCurrentDir__)
if __strTopDir__ not in sys.path:
    sys.path.insert(0, __strTopDir__)

sys.path.insert(0, os.path.join(__strCurrentDir__, 'lib', 'MySQL_python-1.2.5-py2.5-linux-x86_64.egg'))
import MySQLdb;

from log import error, warning, debug, info;

class CMysql:
    def __init__(self, strHost, strUsr, strPwd, strDb, nPort):
        self.m_oConn = MySQLdb.connect(host = strHost, user = strUsr, passwd = strPwd, db = strDb,
                                       port = nPort, use_unicode=True, charset="utf8")
        self.m_oCur = self.m_oConn.cursor();

    def Execute(self, strSql):
    #    debug(strSql, True);
        self.m_oCur.execute(strSql);
        self.m_oConn.commit();

    def Query(self, strSql):
     #   debug(strSql, True);
        self.m_oCur.execute(strSql);
        return self.m_oCur.fetchall();

class CPanguApsaraStackDb:
    def __init__(self, host, user, passwd, db, port):
        self.m_oDb = CMysql(host, user, passwd, db, port);

    def EscapeJson(self, json):
        return self.m_oDb.m_oConn.escape_string(json);

    def GetDateFromTimeStamp(self, time):
        return time.split()[0] + " 00:00:00";

    def AddClustersBaseInfo(self, mapData):

        id = uuid.uuid1()

        project = mapData["project"]
        mtime = mapData["mtime"]
        clustername = mapData["ClusterName"]
        CsCount = mapData["detail"]["CsCount"]
        CsAbnormalCount = mapData["detail"]["CsAbnormalCount"]
        IsHybird = mapData["detail"]["IsHybird"]
        TotalDiskSize = mapData["detail"]["TotalDiskSize"]
        TotalFreeDiskSize = mapData["detail"]["TotalFreeDiskSize"]
        TotalFileSize = mapData["detail"]["TotalFileSize"]
        TotalUsage = mapData["detail"]["TotalUsage"]
        TotalChunksCount = mapData["detail"]["TotalChunksCount"]
        DiskTotalCount = mapData["detail"]["DiskTotalCount"]
        DiskErrorCount = mapData["detail"]["DiskErrorCount"]
        DiskHangCount = mapData["detail"]["DiskHangCount"]
        DiskMaxUsage = mapData["detail"]["DiskMaxUsage"]
        DiskMinUsage = mapData["detail"]["DiskMinUsage"]
        SSDCacheTotalCount = mapData["detail"]["SSDCacheTotalCount"]
        SSDCacheErrorCount = mapData["detail"]["SSDCacheErrorCount"]


        strSql = "insert into apsara_stack_clusters(id, collect_date, project_name, cluster_name, chunkserver_count, chunkserver_abnormal_count, is_hybird, total_disk_size_gb, \
                total_free_disk_size_gb, total_file_size_gb, total_usage, total_chunks_count, disk_total_count, disk_error_count, disk_hang_count, disk_max_usage, disk_min_usage, \
                ssdcache_total_count, ssdcache_error_count)values('%s', '%s', '%s', '%s', %d, %d, %d, %d,\
                %d, %d, %d, %d, %d, %d, %d, %f, %f, %d, %d); " %(id, mtime, project, clustername, CsCount, CsAbnormalCount, IsHybird, TotalDiskSize, TotalFreeDiskSize,\
                TotalFileSize, TotalUsage, TotalChunksCount, DiskTotalCount, DiskErrorCount, DiskHangCount, DiskMaxUsage, DiskMinUsage, SSDCacheTotalCount, SSDCacheErrorCount)

        try:
            self.m_oDb.Execute(strSql);
        except Exception, e:
            error("Add apsara_stack_clusters failed, " + str(e), True);
            error(str(e), True);
            return False;

        return True;

    def AddDiagnosisResult(self, mapData):

        id = uuid.uuid1()

        project = mapData["project"]
        mtime = mapData["mtime"]
        clustername = mapData["ClusterName"]
        detail = mapData["detail"];

        lsResult = []
        total = 0;
        passed = 0;
        failed = 0;
        for each in detail:
            for key ,value in each.items():
                for eachItem in value:
                    total =  total + 1;
                    if eachItem["CheckDetail"]["status"] == "ok":
                        passed = passed + 1
                    else:
                        failed = failed + 1
                        lsResult.append({eachItem["CheckItem"] : eachItem["CheckDetail"]["failedReason"]})

        lsSql = []
        if failed == 0:
            sql = "insert into apsara_stack_diagnosis_result(id, check_date, project_name, cluster_name, check_item_total, check_item_passed, check_item_failed) \
                    values('%s', '%s', '%s', '%s', %d, %d, %d);" %(id, mtime, project, clustername, total, passed, failed)
            lsSql.append(sql)
        else:
            for each in lsResult:
                for key, value in each.items():
                    sql = "insert into apsara_stack_diagnosis_result(id, check_date, project_name, cluster_name, check_item_total, check_item_passed, check_item_failed, \
                           check_failed_item, check_failed_detail) values('%s', '%s', '%s', '%s', %d, %d, %d, '%s', '%s'); \
                           " %(id, mtime, project, clustername, total, passed, failed, key, value)
                    lsSql.append(sql)

        try:
            for strSql in lsSql:
                self.m_oDb.Execute(strSql);
        except Exception, e:
            error("Add apsara_stack_diagnosis_result failed, " + str(e), True);
            error(str(e), True);
            return False;

        return True;


    # 环境检查结果入库
    def AddEnvCheckResult(self, mapData):
        id = uuid.uuid1()
        project = mapData["project"]
        mtime = mapData["mtime"]
        clustername = mapData["ClusterName"]
        detail = mapData["detail"];

        # 如果环境检查结果为空，则直接返回
        if not detail:
            return;

        # 计算检查项的通过个数，准备结果
        lsResult = []
        detailGroup = {}
        detailGroup["global"] = detail["globalCheckResult"]
        detailGroup["master"] = detail["masterCheckResult"]
        detailGroup["chunkserver"] = detail["chunkserverCheckResult"]

        failed = 0
        total = 0
        for role, detailResult in detailGroup.items():
            for each in detailResult:
                for key, value in each.items():
                    if not self.filterEnvCheckItem(role, key):
                        # 计算总数时，刨掉过滤掉的项
                        total = total + 1
                        if len(value) > 0:
                            lsResult.append({role + "#" + key: value})
                            failed = failed + 1
        passed = total - failed;

        # 生成插入的 sql 语句
        lsSql = []
        if failed == 0:
            sql = "insert into apsara_stack_envcheck_result(id, check_date, project_name, cluster_name, check_item_total, check_item_passed, check_item_failed) \
                    values('%s', '%s', '%s', '%s', %d, %d, %d);" %(id, mtime, project, clustername, total, passed, failed)
            lsSql.append(sql);
        else:
            for each in lsResult:
                for key, value in each.items():
                    role = key.split("#")[0]
                    item = key.split("#")[1]

                    sql = "insert into apsara_stack_envcheck_result(id, check_date, project_name, cluster_name, check_item_total, check_item_passed, check_item_failed, \
                           role, check_failed_item, check_failed_count, check_failed_detail) values('%s', '%s', '%s', '%s', %d, %d, %d, '%s', '%s', '%s', '%s'); \
                           " %(id, mtime, project, clustername, total, passed, failed, role, item, len(value), json.dumps(value))
                    lsSql.append(sql)

        try:
            for strSql in lsSql:
                self.m_oDb.Execute(strSql);
        except Exception, e:
            error("Add apsara_stack_envcheck_result failed, " + str(e), True);
            error(str(e), True);
            return False;

        return True

    # 我们收集的结果是按照普通集群收集的，master 部署在docker 上，部分检查项一定不会通过，我们过滤掉这些检查项
    def filterEnvCheckItem(self, role, item):
        filterGroup = []

        globalFileterGroup =["MachineDistributionRoomStatus", "HostnameConsistency", "RackCapabilityBalance", "UplinkStatus"]
        masterFilterGroup = ["PartitionLabel", "RepeatMount", "MemoryList:SingleHZ", "MemoryTotal", "HaDistribution", "NetInterfaceUplinkCount",
                             "TmpfsPhysicalMemPercent", "CorePattern", "MasterCoreUlimit", "ApsarapanguTotal", "ApsaraTotal", "SwapClosed", "TmpfsExist",
                             "MasterBackupExists_ECS"]
        chunkserverFileterGroup = ["SsdFileSystem", "SsdDiskList", "HddDiskList", "Libcgroup0.37.1Exists", "ChunkserverCoreUlimit",
                                   "IpPortRangeLowerLimit", "HddFileSystem:4kAlign", "HddFileSystem", "ClockSource", "SwapClosed"]

        if role == "master":
            filterGroup = masterFilterGroup;
        elif role == "global":
            filterGroup = globalFileterGroup
        elif role == "chunkserver":
            filterGroup = chunkserverFileterGroup

        # 如果需要过滤掉，返回true
        for each in filterGroup:
            if item.find(each) != -1:
                return True
        # 无需过滤，返回false
        return False

    def GetEnvCheckResult(self, lsItems):
        for eachItem in lsItems:
            print "检查项: ", eachItem
            lsRet = []
            sql = "select project_name, cluster_name, check_failed_count, check_failed_detail from apsara_stack_envcheck_result  WHERE check_failed_item LIKE '%%%s%%';" %(eachItem)
            lsData = self.m_oDb.Query(sql)
            for each in lsData:
                print "    项目: ", each[0], "集群: ", each[1], "失败项数: ", each[2]
                print "    失败详情:", json.dumps(json.loads(each[3]), indent = 4)

    def GetDiagnosisResult(self, lsItems):
        for eachItem in lsItems:
            print "检查项: ", eachItem
            lsRet = []
            sql = "select project_name, cluster_name, check_failed_detail from apsara_stack_diagnosis_result WHERE check_failed_item LIKE '%%%s%%';" %(eachItem)
            lsData = self.m_oDb.Query(sql)
            for each in lsData:
                print "    项目: ", each[0], "集群: ", each[1], "失败详情: ", each[2]

if '__main__' == __name__:

    dbConfig = json.loads(open(os.path.join(__strCurrentDir__, '..', 'conf', "database.json"), 'r').read())
    oDb = CPanguApsaraStackDb(dbConfig["host"], dbConfig["user"], dbConfig["password"], dbConfig["name"], dbConfig["port"]);

    # 数据库里查询关键检查项，并输出
    lsItems = ["DirtyChunks chunksmatch", "PartitionLabel", "RepeatMount", "ErrorMountPoint"]
    ret = oDb.GetEnvCheckResult(lsItems);

    lsItems2 = ["PanguMasterElectStatus"]
    ret = oDb.GetDiagnosisResult(lsItems2);


