#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import socket;
import json;
from const import CConst;
from dayu import CDayu, CDayuClusterInfo;
from tianji import CTianji, CTianjiClusterInfo;
from exception import CStrException,CFatalException;
from log import fatal, error, warning, info, debug;
from flag import SetGlobalFlag, GetGlobalFlag;

class CRunEnv:
    def __init__(self):
        if 1 == int(GetGlobalFlag("pangu_common_EnvMode")):
            self.m_oEnv = CTianji();
        else:
            self.m_oEnv = CDayu();

    def GetLocalIp(self):
        return self.m_oEnv.GetLocalIp();

class CRunEnvClusterInfo:
    def __init__(self):
        if 1 == int(GetGlobalFlag("pangu_common_EnvMode")):
            self.m_oEnvClusterInfo = CTianjiClusterInfo();
        else:
            self.m_oEnvClusterInfo = CDayuClusterInfo();

    def IsLocalExistRole(self, strRole):
        return self.m_oEnvClusterInfo.IsLocalExistRole(strRole);

    def GetHostnameListByRole(self, strRole):
        return self.m_oEnvClusterInfo.GetHostnameListByRole(strRole);

    def GetIplistByRole(self, strRole):
        return self.m_oEnvClusterInfo.GetIplistByRole(strRole);

if '__main__' == __name__:
    print("======= GetLocalIp in Tianji Mode ==========");
    SetGlobalFlag("pangu_common_EnvMode", 1);
    try:
        print(CRunEnv().GetLocalIp());
        print(CRunEnvClusterInfo().GetIplistByRole('all'));
    except Exception, e:
        print(str(e));

    print("\n======= GetLocalIp in Dayu Mode ==========");
    SetGlobalFlag("pangu_common_EnvMode", 0);
    try:
        print(CRunEnv().GetLocalIp());
        print(CRunEnvClusterInfo().GetIplistByRole('all'));
    except Exception, e:
        print(str(e));

