#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import socket;
import json;
import time;
import urllib2;
from flag import GetGlobalFlag;
from common import CEnv, CGlobal, CProcess;
from exception import CStrException,CFatalException;
from log import fatal, error, warning, info, debug;

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
__strMonitorDir__ = os.path.dirname(__strModuleDir__)

class CTianjiConst:
    #tianji-config
    M_CLUSTER_INFO_PATH = os.path.join(__strMonitorDir__, 'conf.global/cluster.json');
    M_ROLE_DEF_PATH = os.path.join(__strMonitorDir__, 'conf.global/services/pangu/role.json');
    M_PANGU_TAG_PATH = os.path.join(__strMonitorDir__, 'conf.global/services/pangu/tag.json');

class CTianji:
    def __init__(self):
        pass;

    def GetLocalIp(self):
        #for test
        return self._GetIpByHostname(CEnv.GetLocalHost());

    def _GetIpByHostname(self, strHost):
        fTimeBegin = time.time();
        oHttp = urllib2.urlopen(GetGlobalFlag("pangu_tianji_query_host_url") + "?m.id=%s" %strHost);
        strOutput = oHttp.read();
        lsIpMap = json.loads(strOutput);

        debug("change host(%s) --> (%s) cost: %s" %(strHost, lsIpMap[0]['m.ip'], time.time() - fTimeBegin), True);
        return lsIpMap[0]['m.ip'];

class CTianjiClusterInfo:
    def __init__(self):
        self.m_mapRole = CGlobal.ParseJson(CTianjiConst.M_ROLE_DEF_PATH)['ServerRoles'];
        self.m_oTianji = CTianji();

    def IsLocalExistRole(self, strRole):
        strLocalHost = CEnv.GetLocalHost();
        return strLocalHost in self.GetHostnameListByRole(strRole);

    def GetHostnameListByRole(self, strRole):
        '''
        strRole such as: PanguMaster, PanguChunkserver
        '''
        #get role.def
        return self.m_mapRole[strRole + '#'];

    def GetIplistByRole(self, strRole):
        lsIp = [];
        for strHost in self.GetHostnameListByRole(strRole):
            lsIp.append(self.m_oTianji._GetIpByHostname(strHost));

        return lsIp;

