#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import time;
import unittest;

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)
    sys.path.insert(0, os.path.dirname(__strModuleDir__))

from common.exception import CStrException;
from mock.dayu_mock import CDayuClusterInfoMock;
from mock.tianji_mock import CTianjiClusterInfoMock;
from mock.http_mock import CHttpMock;
from common.action import CAction, CAliMonitor, CTianjiMonitor, CGlobalMonitor;

class CReportMock:
    def MonitorAction(self, oOpr, strRole, strCaseName, strLevel, strReport):
        print("opr(%s) role(%s) casename(%s) level(%s) report(%s)" %(oOpr, strRole, strCaseName, strLevel, strReport));

class CActionTest(unittest.TestCase):
    def setUp(self):
        self.m_oAction = CAction(CReportMock(), None);

    def tearDown(self):
        pass;

    def testExecute(self):
        self.m_oAction.Execute('test_role', 'ut_test_case', 'ERROR', 'for test result');

class CAliMonitorTest(unittest.TestCase):
    def setUp(self):
        print("--IN CAliMonitorTest Test");
        self.m_oMonitor = CAliMonitor(CDayuClusterInfoMock());

    def tearDown(self):
        pass;

    def testMonitorAction(self):
        self.m_oMonitor.MonitorAction(CHttpMock(), 'current_role', 'test_case', 'ERROR', 'for ali-mointor test report');

class CTianjiMonitorTest(unittest.TestCase):
    def setUp(self):
        print("--IN CTianjiMonitorTest Test");
        self.m_oMonitor = CTianjiMonitor();

    def tearDown(self):
        pass;

    def testMonitorAction(self):
        self.m_oMonitor.MonitorAction(CHttpMock(), 'current_role', 'test_case', 'ERROR', 'for tianji-action test report');

class CGlobalMonitorTest(unittest.TestCase):
    def setUp(self):
        print("--IN CGlobalMonitorTest Test");

    def tearDown(self):
        pass;

    def testMonitorActionByTianji(self):
        try:
            oMonitor = CGlobalMonitor(CTianjiClusterInfoMock());
            oMonitor.MonitorAction(CHttpMock(), 'current_role', 'test_case', 'ERROR', 'for global-mointior in tianji env test report');
        except CStrException, e:
            self.assertEqual(str(e), "threre is no valid global monitor!");

    def testMonitorActionByDayu(self):
        try:
            oMonitor = CGlobalMonitor(CDayuClusterInfoMock());
            oMonitor.MonitorAction(CHttpMock(), 'current_role', 'test_case', 'ERROR', 'for global-mointior in dayu env test report');
        except CStrException, e:
            self.assertEqual(str(e), "threre is no valid global monitor!");

if '__main__' == __name__:
    unittest.main();
