#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import unittest;

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)
    sys.path.insert(0, os.path.dirname(__strModuleDir__))

from common.exception import CStrException,CFatalException;
from mock.tianji_mock import CTianjiClusterInfoMock;

class CClusterInfoTest(unittest.TestCase):
    def setUp(self):
        self.m_oClusterInfo = CTianjiClusterInfoMock();

    def tearDown(self):
        pass;

    def testIsLocalExistRole(self):
        self.assertTrue(self.m_oClusterInfo.IsLocalExistRole('PanguMaster'));
        self.assertTrue(self.m_oClusterInfo.IsLocalExistRole('PanguChunkserver'));

    def testGetHostnameListByRole(self):
        lsHost = self.m_oClusterInfo.GetHostnameListByRole('PanguMaster');
        self.assertTrue(1 == len(lsHost));
        self.assertEqual('xx1x1111.xx1xx', lsHost[0]);

    def testGetIplistByRole(self):
        lsIp = self.m_oClusterInfo.GetIplistByRole('PanguChunkserver');
        self.assertTrue(1 == len(lsIp));
        self.assertEqual('127.0.0.1', lsIp[0]);

if '__main__' == __name__:
    unittest.main();
