#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import time;
import json;
import unittest;

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
__strMonitorDir__ = os.path.dirname(__strModuleDir__);
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)
    sys.path.insert(0, __strMonitorDir__)

from common.exception import CStrException,CFatalException;
from common.common import CGlobal, CProcess;

class CGlobalTest(unittest.TestCase):
    def setUp(self):
        pass;

    def tearDown(self):
        pass;

    def testGetFunc(self):
        oFunc = CGlobal.GetFunc(self, 'testGetFunc');
        self.assertEqual(self.testGetFunc, oFunc);

        try:
            CGlobal.GetFunc(self, 'testGetFuncXX');
            self.assertTrue(False);
        except CStrException, e:
            print(str(e));
            self.assertTrue(True);

    def testGetPyMode(self):
        print('curr file:' + __file__);
        oMod = CGlobal.GetPyMod(__file__);
        self.assertTrue('CGlobalTest' in dir(oMod));
        self.assertFalse('CGlobalTestNOT' in dir(oMod));

        try:
            oMod = CGlobal.GetPyMod('XX' + os.path.basename(__file__));
            self.assertTrue(False);
        except ImportError, e:
            print(e);
            self.assertTrue(True);

    def testGetCheckerFunc(self):
        oFunc = CGlobal.GetCheckerFunc(os.path.join(__strMonitorDir__, 'checker/min.py'));
        oFunc(0, [1, 2, 3]);
        try:
            oFunc(1.1, [1, 2, 3]);
            self.assertTrue(False);
        except CStrException, e:
            print(str(e));
            self.assertTrue(True);

        try:
            CGlobal.GetCheckerFunc(os.path.join(__strMonitorDir__, 'checker/min_not_exist.py'));
            self.assertTrue(False);
        except ImportError, e:
            print(str(e));
            self.assertTrue(True);

    def TestEqual(self, obj1, obj2):
        if type(obj1) != type(obj2):
            raise CStrException("different type between (%s) to (%s)" %(type(obj1), type(obj2)));
        if isinstance(obj1, list):
            if len(obj1) != len(obj2):
                raise CStrExcepton("different len between obj1(%s) to obj2(%s)" %(len(obj1), len(obj2)));
            for i in xrange(0, len(obj1)):
                self.TestEqual(obj1[i], obj2[i]);
        elif isinstance(obj1, dict):
            if len(obj1) != len(obj2):
                raise CStrExcepton("different len between obj1(%s) to obj2(%s)" %(len(obj1), len(obj2)));
            for strKey in obj1:
                self.TestEqual(obj1[strKey], obj2[strKey]);
        else:
            if obj1 != obj2:
                raise CStrException("different value between (%s) to (%s)" %(obj1, obj2));

    def testParserJson(self):
        strJson = '/tmp/test_common.tmp';
        mapTest = {u'a' : u'aaa', u'b' : [u'1', 2, 3, u'4'], u'c' : {u'aa' : u'aaaaaa', u'b' : [1, 2, 3], u'cc' : {}}};
        json.dump(mapTest, open(strJson, 'w'));

        mapGet = CGlobal.ParseJson(strJson);
        self.TestEqual(mapGet, mapTest);

        #test load not exist json
        self.assertFalse(CGlobal.ParseJson(strJson + '_not_exist', True));

        try:
            self.assertFalse(CGlobal.ParseJson(strJson + '_not_exist'));
            self.assertTrue(False);
        except IOError, e:
            print(str(e));
            self.assertTrue(True);

class CProcessTest(unittest.TestCase):
    def setUp(self):
        pass;

    def tearDown(self):
        pass;

    def testRunCmd4NoException(self):
        nRet, strOutput = CProcess.RunCmd4NoException("ls");
        self.assertEqual(nRet, 0);

        nRet, strOutput = CProcess.RunCmd4NoException("ls /tmp/not_exist_file.tmp");
        self.assertEqual(nRet, 2);

    def testRunCmd(self):
        CProcess.RunCmd("ls");

        try:
            CProcess.RunCmd("ls /tmp/not_exist_file.tmp");
            self.assertTrue(False);
        except CStrException, e:
            print(str(e));
            self.assertTrue(True);

if '__main__' == __name__:
    unittest.main();
