#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os;
import sys;
import time;
import unittest;

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)
    sys.path.insert(0, os.path.dirname(__strModuleDir__))

from common.exception import CStrException,CFatalException;
from common.flag import CFlagException, GetGlobalFlag, SetGlobalFlag;

class CFlagTest(unittest.TestCase):
    def setUp(self):
        pass;

    def tearDown(self):
        pass;

    def testGlobalFlag(self):
        #test for normal used
        SetGlobalFlag("aa", 'ValueAa');
        self.assertEqual(GetGlobalFlag('aa'), 'ValueAa');
        self.assertEqual(GetGlobalFlag('Aa'), 'ValueAa');
        self.assertEqual(GetGlobalFlag('AA'), 'ValueAa');
        self.assertTrue(GetGlobalFlag('aa') != 'VALUEAA');

        #test get set time
        self.assertTrue(GetGlobalFlag('aa', True) < time.time());

        #test set time
        SetGlobalFlag("aa", 'ValueAa', 100);
        self.assertTrue(GetGlobalFlag('aa', True), 100);

        #test not exist key
        try:
            GetGlobalFlag("not exist key");
            self.assertTrue(False);
        except CFlagException, e:
            print(str(e));

if '__main__' == __name__:
    unittest.main();
