#! /usr/bin/env python
import os
import subprocess
from optparse import OptionParser

def RunCmd(strCmd):
    try:
        strOut = subprocess.check_output(strCmd, shell=True)
        lsLogs = strOut.strip().split('\n')
        return 0, strOut
    except subprocess.CalledProcessError, e:
        return e.returncode, e.output

def GetChunkserverList():
    strPuadmin = '/apsara/deploy/puadmin'
    strCmd = '''%s lscs |grep tcp'''%(strPuadmin)
    nRet, strOut = RunCmd(strCmd)
    lsCs = []
    if nRet == 0:
        lsLines = strOut.strip().split('\n')
        for strLine in lsLines:
            for s in strLine.strip().split():
                if s.startswith('tcp'):
                    lsCs.append(s)
    else:
        print "Error: %s"%(strOut)
    return lsCs

def GetChunkserverMetaWithTimeout(strCs):
    strPuadmin = '/apsara/deploy/puadmin'
    strCmd = '''%s cs -meta %s --all'''
    ''' | grep FileId'''%(strPuadmin, strCs)
    nRet, strOut = RunCmd(strCmd)
    lsChunks = []
    if nRet == 0:
        lsLines = strOut.strip().split('\n')
        for strLine in lsLines:
            lsMeta = strLine.strip().split()
            strChunkId = '_'.join([lsMeta[1], lsMeta[3]])
            lsChunks.append(strChunkId)
    else:
        print "Error: %s"%(strOut)

    return lsChunks

def GetChunkserverMeta(strCs):
    strPuadmin = '/apsara/deploy/puadmin'
    strCmd = '''%s cs -meta %s --all | grep FileId'''%(strPuadmin, strCs)
    nRet, strOut = RunCmd(strCmd)
    lsChunks = []
    if nRet == 0:
        lsLines = strOut.strip().split('\n')
        for strLine in lsLines:
            lsMeta = strLine.strip().split()
            strChunkId = '_'.join([lsMeta[1], lsMeta[3]])
            lsChunks.append(strChunkId)
    else:
        print "Error: %s"%(strOut)

    return lsChunks


def CheckChunkIntersection(strCsLeft, strCsRight):
    setChunksLeft = set(GetChunkserverMeta(strCsLeft))
    setChunksRight = set(GetChunkserverMeta(strCsRight))

    return setChunksLeft & setChunksRight

def CheckChunkIntersectionAll(strCsLeft, strCsRight):
    lsCs = GetChunkserverList()
    if len(lsCs) > 1:
        for idx, left in enumerate(lsCs):
            for right in lsCs[idx+1:]:
                setIntersection = CheckChunkIntersection(left, right)
                if setIntersection:
                    print "%s and %s share %d chunks"%(left, right, len(setIntersection))
                else:
                    print "%s and %s share no chunk"%(left, right)

def GetOptions():
    mapOptions = {}
    oParser = OptionParser()
    oParser.add_option('-l', '--left', action='store', dest='left', default='',
            help='''Left chunkserver to compare''')
    oParser.add_option('-r', '--right', action='store', dest='right', default='',
            help='''Right chunkserver to compare''')
    oParser.add_option('-a', '--all', action='store_true', dest='all', default=False,
            help='''Compare all chunkserver''')
    option, args = oParser.parse_args()
    if option.left:
        mapOptions['left'] = option.left
    if option.right:
        mapOptions['right'] = option.right
    if option.all:
        mapOptions['all'] = option.all

    return mapOptions

if __name__ == '__main__':
    mapOptions = GetOptions()
    if 'all' in mapOptions.keys():
        CheckChunkIntersectionAll()
    elif 'left' in mapOptions.keys() and 'right' in mapOptions.keys():
        setIntersection = CheckChunkIntersection(mapOptions['left'], mapOptions['right'])
        if setIntersection:
            print "%s and %s share %d chunks"%(mapOptions['left'], mapOptions['right'], len(setIntersection))
        else:
            print "%s and %s share no chunk"%(mapOptions['left'], mapOptions['right'])
