#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os
import sys
import commands
import json
import uuid;
import copy

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)

from common.common import CProcess
from common.common import CEnv
from common.log import info, error

# 底座机器的机器数不多，0153 的chunkserver 未分chunk，如果chunk 数量太多，启动时会有问题
# 现通过遍历pangu 目录，找到文件数最多和空间最大的目录，和应用一起，评估数据的合理性
class FindMaxDir:
    def __init__(self):
        #
        self.m_lsFilePath = [];
        self.m_lsDir = [];
        pass;


    # 遍历文件夹
    def  TraverseDir(self, path):
        if path[-1] != '/':
            path = path + '/'

        lsResult = []
        strCmd = "/apsara/deploy/pu ls pangu://localcluster/" + path
        nRet, strOut = CProcess.RunCmd4NoException(strCmd);
        if nRet == 0 and len(strOut) > 0:
            for each in strOut.split("\n"):
                fullpath = path + each;
                if each[-1] == "/":
                    strQuotaCmd = "/apsara/deploy/pu quota pangu://localcluster/" + fullpath
                    ret, out = CProcess.RunCmd4NoException(strQuotaCmd);
                    if ret == 0 and len(out) > 0:
                        lsResult.append(self.AnalyzeOneDir(out))
        else:
            print strOut
            return []

        return lsResult;

    # 分析一个目录的quota 信息，返回一个list，值依次为
    # path, EntryNumber, FileNumber, FilePhysicalLength, FileLogicalLength
    def AnalyzeOneDir(self, quotaStr):
        lsStr = quotaStr.split("\n")

        path = ""
        EntryNumber = 0;
        FileNumber = 0;
        FilePhysicalLength = 0;
        FileLogicalLength = 0;
        index = 0;
        for each in lsStr:
            if each.find("quota under") != -1:
                path = each.split()[-1]
            if each.find("EntryNumber") != -1:
                EntryNumber = self.GetOneUsedValue(lsStr, index)
            if each.find("FileNumber") != -1:
                FileNumber = self.GetOneUsedValue(lsStr, index)
            if each.find("FilePhysicalLength") != -1:
                FilePhysicalLength = self.GetOneUsedValue(lsStr, index) / (1024 * 1024 * 1024)
            if each.find("FileLogicalLength") != -1:
                FileLogicalLength = self.GetOneUsedValue(lsStr, index) /(1024 * 1024 * 1024)

            # index 增加，以保证used取值准确
            index = index + 1;

        return [path, EntryNumber, FileNumber, FilePhysicalLength , FileLogicalLength]

    def GetOneUsedValue(self, lsStr, index):
        ret = 0
        for each in lsStr[index:]:
            if each.find("Used") != -1:
                ret = int(each.split(":")[1])
                break;
        return ret;

    def GetMaxDir(self, lsValue):
        if len(lsValue) == 0:
            return;

        print "***ResultFormat: [panguDirPath, EntryNumber, FileNumber, FilePhysicalLength(GB), FileLogicalLength(GB)]***"

        print "Max FileNumber Dir:"
        lsValue.sort(key = getFileNumber)
        print "  ", lsValue[-1]

        print "\nMax EntryNumber Dir:"
        lsValue.sort(key = getEntryNumber)
        print "  ", lsValue[-1]

        print "\nMax FilePhysicalLength Dir:"
        lsValue.sort(key = getFilePhysicalLength)
        print "  ", lsValue[-1]

        print "\nMax FileLogicalLength Dir:"
        lsValue.sort(key = getFileLogicalLength)
        print "  ", lsValue[-1]

# 回调函数，列表排序，指定排序值
def getFileNumber(lsValue):
    return lsValue[1];

def getEntryNumber(lsValue):
    return lsValue[2];

def getFilePhysicalLength(lsValue):
    return lsValue[3];

def getFileLogicalLength(lsValue):
    return lsValue[4];

if '__main__' == __name__:

    if  len(sys.argv) != 2:
        print ("Usage: " + sys.argv[0] + " path")
        exit(2)

    obj = FindMaxDir();
    path =  sys.argv[1];

    if path.startswith("pangu://localcluster/"):
        path = path[len("pangu://localcluster/"):]

    lsRet = obj.TraverseDir(path)
    obj.GetMaxDir(lsRet)

