#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os
import sys
import commands
import json
import uuid;
import copy
import time

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)

from common.common import CProcess
from common.common import CEnv
from common.log import info, error

# 通过检查raf 的bitmap，获取不同的bitmap，拿到每个chunk 的 创建时间，如果是换盘前，则ok，否则有风险
# bitmap 分析后的样例如下
#{
#    "66605_data_2774548873218": [
#        {
#            "ChunkId:14 Version:12884901891 ChunkFlag:CHUNK_ALIGNED_4_RANDOM ReplicaNum:3 CSInfo:\n": [
#                "ChunkId:14 Version:12884901891 ChunkFlag:CHUNK_ALIGNED_4_RANDOM ReplicaNum:3 CSInfo:\n",
#                "{\n",
#                "\t[Status:normal]\n",
#                "\t[Location:tcp://10.3.180.218:10260]\n",
#                "\t[DiskId:6]\n",
#                "\t[Bitmap: 00110000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000]\n",
#                "\t[Status:normal]\n",
#                "\t[Location:tcp://10.3.180.176:10260]\n",
#                "\t[DiskId:5]\n",
#                "\t[Bitmap: 00110000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000]\n",
#                "\t[Status:normal]\n",
#                "\t[Location:tcp://10.3.180.158:10260]\n",
#                "\t[DiskId:3]\n",
#                "\t[Bitmap not set in response. Bitmap of the chunk is initializing or chunk file does not exist.]\n",
#                "}\n"
#            ]
#        }
#    ]
#}
#puadmin chunkserver/cs -meta tcp://10.230.203.200:10260 --seterror --chunk=123_0

class GetChunkCtime:
    def __init__(self):
        self.m_totalChunk = 0
        self.m_cmdls = ""
        self.m_standardTime = "2018-10-26 00:00:00"
        pass;

    def checkOneChunk(self, detail, chunkId):
        for each in detail:
            if each.find("Location") != -1:
                ip = each.split("//")[1].split(":")[0]

            if each.find("DiskId") != -1:
                disk = each.split(":")[1][:-2]

                crtime = self.getCtimeFromOneCs(ip, disk, chunkId)

                ret = self.CompareTime(self.m_standardTime, crtime)
                if not ret:
                    print ip, disk, chunkId, crtime, "net set error"
                    cmd = "/apsara/deploy/puadmin cs -meta tcp://" + ip + ":10260 --seterror --chunk=" + chunkId
                    self.m_cmdls = self.m_cmdls + cmd + '\n'

    def CompareTime(self, standard, crtime):
        # crtime 形如   Thu Mar 15 16:55:28 2018
        # standard 形如 2018-11-12 15:33:12

        lsTime = crtime.split()
        crtime_year = lsTime[-1]
        crtime_time = lsTime[-2]
        crtime_day = lsTime[-3]
        crtime_month = lsTime[-4]
        month_str = "Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec"
        lsMonth = month_str.split("_")
        index = 0;
        for each in lsMonth:
            index = index + 1
            if crtime_month == each:
                crtime_month = str(index)
                break;

        crtime = crtime_year + '-' + crtime_month + '-' + crtime_day + " " + crtime_time

        crtime_localtime = time.strptime(crtime, '%Y-%m-%d %H:%M:%S')
        crtime_time = time.mktime(crtime_localtime)

        standard_localtime = time.strptime(standard, '%Y-%m-%d %H:%M:%S')
        standard_time = time.mktime(standard_localtime)

        # 如果 chunk的创建时间，小于下盘时间，则认为chunk 合法，返回true
        if  standard_time - crtime_time > 0:
            return True

        return False

    def getCtimeFromOneCs(self, ip, disk, chunkid):

        #return "Thu Mar 15 16:55:28 2018"

        # 通过命令拿到 df， 确定出文件名
        dev = ""
        diskMount = "/apsarapangu/disk" + disk
        nRet, strOut = CProcess.RunCmd4NoException("ssh " + ip + " df |grep " + diskMount);
        if nRet == 0:
            for each in strOut.split("\n"):
                lsIntems = each.split()
                if lsItems[-1] == diskMount:
                    dev = lsItems[0]
                    break;

        #uuidStr = ""
        #nRet, strOut = CProcess.RunCmd4NoException("ssh " + ip + "sudo ls -l " + diskMount + "/chunks");
        #if nRet == 0:
        #    for each in strOut.split("\n"):
        #        if len(each) > 36:
        #            uuidStr = each.split()[-1]

        #sudo debugfs -c /dev/sdj1 -R "stat chunks/f4c66ca6-4ad3-4d45-896d-abf4bf473a76"""
        cmd = "ssh " + ip + ' sudo debugfs -c ' + dev + ' -R "stat chunks/' + chunkid + '"\''
        nRet, strOut = CProcess.RunCmd4NoException(cmd);
        if nRet == 0:
            for each in strOut.split("\n"):
                if each.find("crtime") != -1:
                    crtime =  each.split("--")[1]
                    return crtime

        return ""


    # 获取每个chunk的 创建时间
    def  GetChunks(self, filepath):
        # 标准 json，直接 load
        obj =  json.loads(open(filepath, 'r').read())
        for file, chunks in obj.items():
            fileId = file.split("_")[-1]
            for eachChunk in chunks:
                for chunk, detail in eachChunk.items():
                    chunkIndex = chunk.split()[0].split(":")[1]
                    chunkId = fileId + "_" + chunkIndex
                    self.checkOneChunk(detail, chunkId)


    # 输出结果到本地文件
    def PrintResult(self):
        nRet, strOut = CProcess.RunCmd4NoException("hostname");
        open("set_chunk_error.sh", 'w').write(self.m_cmdls)
        print self.m_cmdls

if '__main__' == __name__:

    if len(sys.argv) != 2:
        print sys.argv[0] +  " bitmapfilepath"
        sys.exit(-1)

    path = sys.argv[1]

    obj = GetChunkCtime();

    obj.GetChunks(path)
#    print  obj.CompareTime("2018-10-26 15:33:12", "Thu Mar 15 16:55:28 2018")

    obj.PrintResult();
