#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os
import sys
import time
import commands
import json
from hashlib import md5

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)

from common.log import info, warning, error, fatal

class PanguStatusCollect:
    def __init__(self):
        self.m_result = {};

    # 获取logid，只拿到 primaryid 即可
    def GetLogId(self):
        cmd = "/apsara/deploy/puadmin gss"
        nRet, strProcess = commands.getstatusoutput(cmd)
        if nRet != 0:
            error(cmd + " execute failure, " + strProcess, True)
            return -1
        for each in strProcess.split('\n'):
            if each.find("PrimaryCurrentLogId") != -1:
                primaryLogId = int(each.split(":")[1].strip())
                self.m_result["PrimaryLogId"] = primaryLogId;
                return 0;

    # 获取一个类型的 abnchunk 个数
    def GetOneTypeAbnchunk(self, type):
        cmd = "/apsara/deploy/puadmin fs -abnchunk -t "
        nRet, strOut = commands.getstatusoutput(cmd + type)
        if nRet != 0:
            error(cmd + type + " execute failure, " + strOut, True)
            return -1
        count = 0;
        for each in strOut.split('\n'):
            if each.find('_') != -1:
                count = count + 1

        self.m_result["AbnChunk_Count_" + type] = count;
        return 0

    # 获取abnchunk 个数
    def GetAbnchunk(self):
        ret1 = self.GetOneTypeAbnchunk("none")
        ret2 = self.GetOneTypeAbnchunk("onecopy")
        ret3 = self.GetOneTypeAbnchunk("lessmin")
        return ret1 + ret2 + ret3

    def GetCapability(self):
        cmd = "/apsara/deploy/puadmin lscs "
        nRet, strOut = commands.getstatusoutput(cmd)
        if nRet != 0:
            error(cmd + " execute failure\n " + strOut, True)
            return -1

        csCount = 0;
        for each in strOut.split("\n"):
            if each.find("NORMAL") != -1 and each.find("tcp") != -1:
                csCount = csCount + 1
            if each.find("Total Disk Size:") != -1:
                self.m_result["TotalDiskSizeGB"] =  int(each.split(":")[1].split()[0])
            if each.find("Total File Size:") != -1:
                self.m_result["TotalFileSizeGB"] =  int(each.split(":")[1].split()[0])

        self.m_result["NormalCsTotalCount"] =  csCount;
        return 0

    def GetClusterName(self):
        command = "/bin/me"
        if os.path.exists("/bin/tj_show"):
            command = "/bin/tj_show"

        nRet, strClusterName = commands.getstatusoutput(command + ' 2>/dev/null | /bin/grep Local_cluster |cut -d \: -f 2 | tr -d " "')
        if nRet!= 0:
            error(command + " execute failure \n " + strClusterName, True)
            return "";

        return strClusterName;

    def GetData(self):
        return self.m_result;

if __name__ == '__main__':

    obj = PanguStatusCollect();
    obj.GetLogId();
    obj.GetAbnchunk();
    obj.GetCapability();

    ret = obj.GetData();
    print json.dumps(ret, indent = 4);
    print obj.GetClusterName()


