#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os
import sys
import time
import commands
import json

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)

from common.log import info, warning, error, fatal
from pangu_status_collect import PanguStatusCollect

# bug #25878919
# 为了防止上下电后，pangu 服务出现非预期的异常
# 在盘古停服之前，收集盘古的信息，包括
#   logid 信息
#   abnchunk 信息
#   容量信息
# 待上电完成后，通过这些信息检查盘古状态
class PanguStatusSave:
    def __init__(self):
        self.m_collect = PanguStatusCollect();

    # 结果写入文件
    def WriteResult(self, result):

        strClusterName = self.m_collect.GetClusterName()

        dstFile ="pangu_status_" + strClusterName + ".json"
        path = os.path.join(__strCurrentDir__, dstFile)
        open(path, "w").write(json.dumps(result, indent = 4))

        info(json.dumps(result, indent = 4), True)
        info("write result execute success, cluster: " + strClusterName, True)

        return 0;

    def Run(self):
        info("begin save pangu status", True)

        # 获取pangu 关键信息
        if self.m_collect.GetLogId() != 0:
            return 1;

        if self.m_collect.GetAbnchunk() != 0:
            return 2;

        if self.m_collect.GetCapability() != 0:
            return 3;

        # pangu关键信息保存到文件
        if self.WriteResult(self.m_collect.GetData()) != 0:
            return 4;

        info("end save pangu status\n\n", True)

        return 0;

if __name__ == '__main__':

    obj = PanguStatusSave();
    ret = obj.Run();
    sys.exit(ret)
