#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os
import sys
import commands
import json
import uuid;
import copy
import time

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)

from common.common import CProcess
from common.common import CEnv
from common.log import info, error

# 检查 raf 文件，每个chunk 的 bitmap 是否相同， puadmin fs -bitmap 样例如下
#No master address specified, using nuwa://localcluster/sys/pangu/master
#Master Address: nuwa://localcluster/sys/pangu/master
#--------------------------------------------------------------------------------------------------------------------------------
#/houyi/2/houyi_17984205/data Info:
#FileId:27627909707464715
#FileType:RANDOM_ACCESS_FILE_TYPE_FLAG
#CompressType:NO_COMPRESSION_NO_HEADER
#ChunkNumber:4000
#AppName:MachineLevel-cn-hangzhou-bja001-a-2-3
#PartName:i-fe3b1xf1wfq8c3pinwhq
#CreateTime:20170705104834
#LastModifyTime:20181114192111
#FileLength:268435456000
#FileFlag:RANDOM_ACCESS_FILE_TYPE_FLAG
#MinCopy:2
#MaxCopy:3
#ChunkId:0 Version:167503724545 ChunkFlag:CHUNK_CHECKINED_4_RANDOM ReplicaNum:3 CSInfo:
#{
#        [Status:normal]
#        [Location:tcp://10.125.162.3:10260]
#        [DiskId:11]
#        [Bitmap: 11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111]
#        [Status:normal]
#        [Location:tcp://10.125.161.156:10260]
#        [DiskId:7]
#        [Bitmap: 11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111]
#        [Status:normal]
#        [Location:tcp://10.125.160.123:10260]
#        [DiskId:9]
#        [Bitmap not set in response. Bitmap of the chunk is initializing or chunk file does not exist.]
#}
#ChunkId:1 Version:167503724545 ChunkFlag:CHUNK_CHECKINED_4_RANDOM ReplicaNum:3 CSInfo:
#{
#}

class SearchRepeatBitmap:
    def __init__(self):
        self.m_totalChunk = 0
        self.m_abnChunk = 0
        self.m_totalFile = 0
        self.m_abnFile = 0
        self.m_result = {}
        self.m_chunkId = ""
        pass;

    # 只要有不一样的chunk，就认为不同
    def checkOneChunk_1(self, lsList):
        bitmapSet = set()

        for each in lsList:
            if each.find ("Bitmap") != -1:
                bitmapSet.add(each)
        if len(bitmapSet) > 1:
            return False

        return True;

    # 如果两个 chunk 是满的，另一不满，认为是可以恢复的，不算不一样
    def checkOneChunk_2(self, lsList):
        bitmapSet = set()

        for each in lsList:
            if each.find ("Bitmap") != -1 and each.find("0") != -1:
                bitmapSet.add(each)
        if len(bitmapSet) > 1:
            return False

        return True;

    # 所有的chunk不一样, 认为是不一样的
    def checkOneChunk_3(self, lsList):
        bitmapSet = set()

        totalChunk = 0;
        for each in lsList:
            if each.find ("Bitmap") != -1:
                totalChunk = totalChunk + 1
                bitmapSet.add(each)
        if totalChunk > 0 and len(bitmapSet) == totalChunk:
            return False

        return True;

    # 查 chunk 的覆盖关系，找到最多的chunk，只要能覆盖住短的就可以， 期望是空，实际也是空
    def checkOneChunk_4(self, lsList):
        lsBitmap = []

        for each in lsList:
            if each.find ("Bitmap") != -1:
                currBit = each.split()[1][:-1]
                lsBitmap.append(currBit)

        # 找到最多的 1
        maxBitMap = ""
        maxBitMap_1_count = 0;
        for each in lsBitmap:
            currEach1Count = 0
            for i in each:
                if i == "1":
                    currEach1Count = currEach1Count + 1
            if currEach1Count > maxBitMap_1_count:
                maxBitMap = each;
                maxBitMap_1_count = currEach1Count

        # 开始比较是否覆盖， max 是 0，被比较的是 1， 则算未覆盖，期望是空
        for each in lsBitmap:
            for max, i in zip(maxBitMap, each):
                if max == '0':
                    if i == '1':
                        return False

        return True;


    # 查 chunk 的覆盖关系，如果 1 多的chunk 少于 1 小的chunk，就会很危险
    def checkOneChunk_5(self, lsList):
        lsBitmap = []

        for each in lsList:
            if each.find ("Bitmap") != -1:
                currBit = each.split()[1][:-1]
                lsBitmap.append(currBit)

        chunk_count = {}
        # 确定每个 chunk 1 中 1 的个数
        for each in lsBitmap:
            currEach1Count = 0
            for i in each:
                if i == "1":
                    currEach1Count = currEach1Count + 1
            if currEach1Count > 0:
                if currEach1Count in chunk_count:
                    chunk_count[currEach1Count] = currEach1Count + 1
                else:
                    chunk_count[currEach1Count] = 1

        print chunk_count
        lsCount = []
        i = 0
        while i <= 128:
            if i in chunk_count and chunk_count[i] > 0:
                lsCount.append(chunk_count[i])
            i = i + 1

        print lsCount
        if lsCount != lsCount.sort():
            return False

        return True;


    # chunk 是否重复
    def  OneFileisRepeat(self, filepath):
        oneFileResult = []
        key = "";
        chunkDetail = []
        fileid = ""
        for each in open(filepath, 'r').readlines():

            if each.find("FileId") != -1:
                fileid = each.split(":")[1][:-1]

            # ChunId 行为一个chunk 的开始，初始化变量
            if each.find("ChunkId") != -1:
                self.m_totalChunk = self.m_totalChunk + 1
                key = each;
                bitmap = set()
                chunkDetail = []

            chunkDetail.append(each)

            # } 为一个chunk 的结束，输出结果，重置变量
            if each.find("}") != -1:

                #################################################################
                #################################################################

                if not self.checkOneChunk_1(chunkDetail):
                    self.m_abnChunk = self.m_abnChunk + 1
                    #ChunkId:0 Version:167503724545 ChunkFlag:CHUNK_CHECKINED_4_RANDOM ReplicaNum:3 CSInfo:
                    self.m_chunkId = self.m_chunkId +fileid + '_' + (key.split()[0]).split(":")[1] + '\n'
                    resMap = {}
                    resMap[key] = chunkDetail
                    oneFileResult.append(resMap)
                    key = ""
                    chunkDetail = []

        return fileid, oneFileResult

    def TraverseDir(self, dir):
        files = os.listdir(dir)
        for eachFile in files:
            self.m_totalFile = self.m_totalFile  +1
            print "Check " + eachFile

            path = os.path.join(dir, eachFile)
            fileid, ret = self.OneFileisRepeat(path)
            if len(ret) > 0:
                self.m_abnFile = self.m_abnFile + 1
                self.m_result[eachFile + "_" + fileid] = ret
                print  "\n##### " + eachFile + " FIND ERROR CHUNK #####"
                print  ret

    # 输出结果到本地文件
    def PrintResult(self):
        nRet, strOut = CProcess.RunCmd4NoException("hostname");
        open("repeat_bitmap_" + strOut + ".json", 'w').write(json.dumps(self.m_result, indent = 4))
        open("repeat_bitmap_chunkids_" + strOut + ".txt", 'w').write(self.m_chunkId)
        print "totalchunk is ",  self.m_totalChunk
        print "abnchunk is ",  self.m_abnChunk
        print "totalFile is ",  self.m_totalFile
        print "abnFile is ",  self.m_abnFile

if '__main__' == __name__:

    if len(sys.argv) != 2:
        print sys.argv[0] +  " bitmapfilepath"
        sys.exit(-1)

    path = sys.argv[1]

    obj = SearchRepeatBitmap();

    obj.TraverseDir(path)

    obj.PrintResult();
