#!/home/tops/bin/python2.7
# -*- coding: utf-8 -*-
import os
import sys
import commands
import json
import uuid;
import copy
import time

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
if __strModuleDir__ not in sys.path:
    sys.path.insert(0, __strModuleDir__)

from common.common import CProcess
from common.common import CEnv
from common.log import info, error

# 来宾技侦发现 chunkserver 有重复的chunk，导致启动时assert，
# 查数据盘，检查是否有重复chunk
class SearchRepeatReplica:
    def __init__(self):

        # 维护一个全局的信息，所有的chunk 放在这个map 里，key 为chunk 名称 ，value 为全路径
        self.m_AllChunks = {};

        # 重复的chunk，key 为chunk 名称，value 为全路径列表
        self.m_RepeatChunks = {};

        # 重复的chunk，key 为chunkid，value 为一个 map，key 为路径，value 为stat 信息
        self.m_RepeatChunkDetail = {};
        pass;

    # chunk 是否重复
    def  isRepeat(self, chunk, fullPath):
        if chunk not in self.m_AllChunks:
            self.m_AllChunks[chunk] = fullPath
        else:
            if chunk not in self.m_RepeatChunks:
                # 第一次进入 repeat 列表， all 里的要放进去
                self.m_RepeatChunks[chunk] = []
                self.m_RepeatChunks[chunk].append(self.m_AllChunks[chunk])
            self.m_RepeatChunks[chunk].append(fullPath)


    def TraverseDir(self, sleeptimePreDisk):
        rootDir = "/apsarapangu"
        disks = os.listdir(rootDir)
        for eachDisk in  disks:
            if not eachDisk.startswith("disk"):
                continue
            print eachDisk

            # 定位到 /apsarapangu/disk*/chunks
            diskPath = os.path.join(rootDir, eachDisk, "chunks")
            if not os.path.exists(diskPath):
                continue
            diskDirs = os.listdir(diskPath)
            for eachDiskDir in diskDirs:
                #a2079bb6-067d-4225-a1ab-cb8278f410ed
                if len(eachDiskDir.split('-')) != 5:
                    continue
                time.sleep(sleeptimePreDisk)

                chunksPath = os.path.join(diskPath, eachDiskDir)
                chunks = os.listdir(chunksPath)
                for each in chunks:
                    chunkFullPath = os.path.join(chunksPath, each)
                    if os.path.isfile(chunkFullPath) and len(each.split('_')) == 2:
                        self.isRepeat(each, chunkFullPath)
                    # 适配 016， chunks 分目录
                    if os.path.isdir(chunkFullPath):
                        subChunks = os.listdir(chunkFullPath)
                        for eachsubchunk in subChunks:
                            subchunkFullPath = os.path.join(chunkFullPath, eachsubchunk)
                            if os.path.isfile(subchunkFullPath) and len(eachsubchunk.split("_")) == 2:
                                self.isRepeat(eachsubchunk, subchunkFullPath)

    # 获取重复chunk 的stat 信息
    def GetStatInfo(self):
        for chunkid, chunkPath in  self.m_RepeatChunks.items():
            mapTmp = {}
            for each in chunkPath:
                lsTmp = []
                nRet, strOut = CProcess.RunCmd4NoException("stat " + each);
                if nRet == 0:
                    for statEach in strOut.split('\n'):
                        lsTmp.append(statEach)

                nRet2, strOut2 = CProcess.RunCmd4NoException("md5sum " + each);
                if nRet == 0:
                    lsTmp.append('md5 : ' + strOut2)

                mapTmp[each] = lsTmp

            self.m_RepeatChunkDetail[chunkid] = mapTmp




    # 输出结果到本地文件
    def PrintResult(self):
        nRet, strOut = CProcess.RunCmd4NoException("hostname");
        open("repeat_chunks_" + strOut + ".json", 'w').write(json.dumps(self.m_RepeatChunks, indent = 4))

        self.GetStatInfo();
        open("repeat_chunks_detail_" + strOut + ".json", 'w').write(json.dumps(self.m_RepeatChunkDetail, indent = 4))


if '__main__' == __name__:

    obj = SearchRepeatReplica();

    obj.TraverseDir(1)

    obj.PrintResult();
