#!/home/tops/bin/python
#-*- encoding: utf-8 -*-
import os;
import sys;
import imp;
import time;
import re
import json
import datetime;
import commands;
import subprocess
import signal

__strCurrentDir__ = os.path.abspath(os.path.dirname(__file__))
__strModuleDir__ = os.path.dirname(__strCurrentDir__)
__strTopDir__ = os.path.dirname(__strModuleDir__);

class CStrException(Exception):
    pass

class CProcess:
    @staticmethod
    def RunCmd(strCmd, bThrowExp = True, bPrintByDebug = True):
        if bPrintByDebug:
            print ("[common][util] run cmd:%s" % strCmd);
        nRet, strOutput = commands.getstatusoutput(strCmd)

        #python bug
        nRet = nRet >> 8;
        if 0 != nRet:
            print ("[common][util] Fail to execute cmd:%s" % strCmd);

        if bThrowExp:
            if (0 != nRet):
                print ("[common][util] Fail to execute cmd:%s" % strCmd);
                raise CStrException(strOutput)
        return strOutput

    @staticmethod
    def RunCmdSubprocess(strCmd, bPrintByDebug = True):
        if bPrintByDebug:
            print ("[common][util] run cmd:%s" % strCmd);
        return subprocess.check_output(strCmd, shell=True)

    @staticmethod
    def ExecCommandTimeout(cmd, timeout = 30):
        tryCount = timeout * 10;
        proc = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell = True)
        while True:
            ret1 = subprocess.Popen.poll(proc)
            if ret1 is None :
                if tryCount > 0:
                    tryCount -= 1;
                    time.sleep(0.1);
                else:
                    # 超时
                    os.kill(proc.pid, signal.SIGKILL),
                    return -1, 'command timeout: ' + cmd;
            elif ret1 == 0:  # 成功
                return 0, '';
            else: # 失败
                (stdoutdata, stderrdata) = proc.communicate()
                if stderrdata != '':
                    return 1, stderrdata;
                elif stdoutdata != '':
                    return 1, "Output Log:\n" + stdoutdata;
                else:
                    return 1, "";

